--- Samples/Browser/include/SampleBrowser_OSX.h.orig	2011-05-08 20:28:04.000000000 +0200
+++ Samples/Browser/include/SampleBrowser_OSX.h	2011-11-10 17:19:22.000000000 +0100
@@ -37,7 +37,30 @@
 
 #ifdef __OBJC__
 
+#ifdef OGRE_STATIC_LIB
+// HACK warning:
+// In a static build, all of the plugin headers are #included.
+// Unfortunately, the plugin headers have "using namespace" directives
+// which end up pulling in some Ogre data structures whose names collide
+// with the MacOS X Carbon API which is indirectly included by Cocoa.h.
+// Since this part of the code does not use Carbon, we can more/less
+// harmlessly change the names of the conflicting types.
+
+#define FileInfo Carbon_FileInfo
+#define Rect ::Rect
 #import <Cocoa/Cocoa.h>
+#undef FileInfo
+#undef Rect
+
+#else
+
+// OGRE is not built statically, so there's no namespace pollution in the
+// sample code, hence the Cocoa API and its legacy Carbon headers can be
+// imported without special intervention.
+
+#import <Cocoa/Cocoa.h>
+
+#endif  // OGRE_STATIC_LIB
 
 // All this does is suppress some messages in the run log.  NSApplication does not
 // implement buttonPressed and apps without a NIB have no target for the action.
